varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying mediump vec4 v_pixelpos;
varying lowp vec4 v_outlineColor;

uniform sampler2D u_texture;

uniform vec4 u_screenSize;


uniform highp float u_time;

#define M_PI 3.1415926535897932384626433832795

void main() {
	float alpha = texture2D(u_texture, v_texCoord).a;
	
	// This is used for fonts and can therefore not make use of uniforms :(
	float speed = -600.0; //Settings.x;
	float power = 20.0; //Settings.y;
	float spacing_length = 500.0; //Settings.z;
	float animation_length = 800.0; //Settings.w;
	
	
	
	float res_scale = u_screenSize.x / u_screenSize.y;
	
	float intensity = sin(clamp(mod(u_time * speed + (res_scale * v_pixelpos.x),spacing_length + animation_length) - spacing_length, 0.0, animation_length) / animation_length * M_PI);
	intensity = pow(max(intensity, 0.0), power);
	
	lowp vec4 outcol;
	outcol.rgb = v_color.rgb * alpha + v_outlineColor.rgb * intensity * v_outlineColor.a * alpha;//mix(v_color.rgb, v_outlineColor.rgb, intensity);
	outcol.a = alpha;
	gl_FragColor = outcol;
}