varying vec4 v_color;
varying vec2 v_texCoord;
varying vec2 v_textureSize;

uniform sampler2D u_texture;

void main() {

    //this will be our RGBA sum
    vec4 sum = vec4(0.0);

    //our original texcoord for this fragment
    vec2 tc = v_texCoord;

    int radius = 2;
    float hstep = 2.5 / v_textureSize.x;
    float vstep = 2.5 / v_textureSize.y;

    float total_weight = 0.0;
    for (int i=-radius; i<=radius; i++)
        for (int j=-radius; j<=radius; j++) {
            vec4 tvalue = texture2D(u_texture, vec2(tc.x + float(j)*hstep, tc.y + float(i)*vstep));
            float weight = 1000.0 / sqrt(sqrt(1.0 + (float(i*i+j*j))));
            sum += tvalue * weight;
            total_weight += weight;
        }
    sum /= total_weight;

    gl_FragColor = vec4(sum.xyz, 1);
}