varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying mediump vec4 v_pixelpos;

uniform sampler2D u_texture;
	
uniform vec4 u_screenSize;

uniform highp float u_time;

// x=speed, y=power, z=spacing length, w=animation length
uniform highp vec4 Settings;

#define M_PI 3.1415926535897932384626433832795

void main() {
	
	float speed = Settings.x;
	float power = Settings.y;
	float spacing_length = Settings.z;
	float animation_length = Settings.w;
	
	float res_scale = u_screenSize.x / u_screenSize.y;
	
	float intensity = sin(clamp(mod(u_time * speed + (res_scale * v_pixelpos.x),spacing_length + animation_length) - spacing_length, 0.0, animation_length)/animation_length * M_PI);
	intensity = pow(max(intensity, 0.0), power);
	
	vec4 tex = texture2D(u_texture, v_texCoord);
	
	gl_FragColor.rgb = v_color.rgb * tex.rgb + vec3(intensity);
	gl_FragColor.a = v_color.a * tex.a * intensity;
}