attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;

uniform lowp vec4 u_materialAmbient;
uniform highp float u_time;

varying mediump vec4 v_color;
varying mediump vec2 v_texCoord;

uniform lowp vec4 u_settings;

void main() {
	v_color = a_color * vec4(u_materialAmbient.a, u_materialAmbient.a, u_materialAmbient.a, 1.0);
	
	vec4 mm = a_position;//*u_modelViewMatrix;
	float speed = u_settings.x;
	float strength = u_settings.y*0.01;
	float freq = u_settings.z*0.01;
	
	vec4 pos = vec4(0.0,0.0,0.0,0.0);
	float offset = sin(u_time*speed+mm.y*freq)*strength*max(0.0,mm.y);
	
	pos.x += offset;
	//vec3 pos = vec3(offset,0.0,0.0);
	gl_Position = u_modelViewProjectionMatrix * (a_position+pos);
	
	v_texCoord = a_texCoord;
}